<?php
/**
 * Copyright © 2018 Filoblu S.p.A. All rights reserved.
 */

namespace FiloBlu\MappConnector\Helper;

/**
 * Class ExceptionHelper
 * @package FiloBlu\MappConnector\Helper
 */
class ExceptionHelper
{
    /**
     * Error Buffer
     *
     * @var array
     */
    private static $_errorBuffer = [];

    /**
     * Error status
     *
     * @var bool
     */
    private static $_errorStatus = false;

    /**
     * Sets the error buffer or throws an error
     *
     * @param $msg
     * @throws \Exception
     */
    public static function throwException($msg,$die = false,$where = '')
    {
        $m = $where . "\n" . $msg;
        if($die) {
            throw new \Exception(
                $m
            );
        }
        else {
            self::$_errorBuffer[] = $m;
        }

        //Sets status error for job
        self::$_errorStatus = true;
    }

    /**
     * Gets the error buffer
     *
     * @return array
     */
    public static function getErrorBuffer()
    {
        return self::$_errorBuffer;
    }

    /**
     * Resets the error buffer
     */
    public static function resetErrorBuffer()
    {
        self::$_errorBuffer = [];
    }

    /**
     * Gets the error status
     *
     * @return array
     */
    public static function getErrorStatus()
    {
        return self::$_errorStatus;
    }

    /**
     * Resets the error status
     */
    public static function resetErrorStatus()
    {
        self::$_errorStatus = [];
    }


}